package envoy.client.ui;

import javax.swing.JScrollPane;

/**
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>PrimaryScrollPane.java</strong><br>
 * Created: <strong>15 Dec 2019</strong><br>
 *
 * @author Kai S. K. Engelbart
 */
public class PrimaryScrollPane extends JScrollPane {

	private static final long serialVersionUID = -4786837444056228439L;

	private int		verticalScrollBarMaximum	= getVerticalScrollBar().getMaximum();
	private boolean	chatOpened					= false;

	public PrimaryScrollPane() { setBorder(null); }

	public void applyTheme(Theme theme) {
		setForeground(theme.getBackgroundColor());
		setBackground(theme.getCellColor());

		getVerticalScrollBar().setBackground(theme.getCellColor());
		getVerticalScrollBar().setUI(new PrimaryScrollBar(theme, true));
		getHorizontalScrollBar().setBackground(theme.getCellColor());
		getHorizontalScrollBar().setUI(new PrimaryScrollBar(theme, false));

		// Automatic scrolling to the bottom
		getVerticalScrollBar().addAdjustmentListener(e -> {
			if (verticalScrollBarMaximum == e.getAdjustable().getMaximum()) return;

			if (chatOpened) {
				e.getAdjustable().setValue(e.getAdjustable().getMaximum());
				verticalScrollBarMaximum	= getVerticalScrollBar().getMaximum();
				chatOpened					= false;
				return;
			}
			if (getVerticalScrollBar().getValue() + getVerticalScrollBar().getVisibleAmount() + 100 >= getVerticalScrollBar().getMaximum()) {
				e.getAdjustable().setValue(e.getAdjustable().getMaximum());
				verticalScrollBarMaximum = getVerticalScrollBar().getMaximum();
			}
		});
	}

	public void setChatOpened(boolean chatOpened) { this.chatOpened = chatOpened; }
}
